A YANG Data Model for Network Resource Partition (NRP)
Bo Wu
Huawei Technologies
101 Software Avenue, Yuhua District
Nanjing
Jiangsu
210012
China
lana.wubo@huawei.com
Dhruv Dhody
Huawei Technologies
Divyashree Techno Park
Bangalore
Karnataka
560066
India
dhruv.ietf@gmail.com
Ying Cheng
China Unicom
Beijing
China
chengying10@chinaunicom.cn
2022
Routing Area
This document defines a YANG data model for managing Network Resource Partition (NRP) topologies and associated resource allocation. The model can be used for the realization of IETF network slice services.

Introduction
[I-D.ietf-teas-ietf-network-slices] defines IETF network slice services that provide connectivity coupled with network resources commitment between a number of endpoints over a shared network infrastructure and, for scalability concerns, defines network resource partition (NRP) to host one or a group of network slice services according to characteristics including SLOs and SLEs. [I-D.dong-teas-nrp-scalability] analyzes the scalability issues of network slice services in detail and suggests candidate technologies of control and forwarding planes of the NRP.
This document defines a YANG model of NRP that the IETF NSC (Network Slice controller) can use to manage NRP instances to realize the network slicing services. According to the YANG model classification of [RFC8309], the NRP model is a network configuration model.

Terminology
The following terms are defined in [RFC6241] and are used in this specification:
- configuration data
- state data
The following terms are defined in [RFC7950] and are used in this specification:
- augment
- data model
- data node
The terminology for describing YANG data models is found in [RFC7950].

Tree Diagrams
The tree diagram used in this document follows the notation defined in [RFC8340].

NRP modelling requirements
[I-D.ietf-teas-ietf-network-slices] section 6.1 introduces the concept of NRP, which is a collection of resources (bufferage, queuing, scheduling, etc.) in the underlay network to provide specific SLOs and SLEs for connectivity constructs of IETF Network Slice services. [I-D.ietf-teas-ns-ip-mpls] provides some solutions to realize network slicing in IP/MPLS networks. [I-D.dong-teas-nrp-scalability] provides analysis and possible optimizations of the control plane and data plane of NRP in IP/MPLS networks for better scalability. The following are some common NRP attributes for NRP management identified based on the analysis:
- NRP instantiation
  - NRP partition type: Refers to various NRP resource partition methods, such as control plane partition, data plane partition, no partition, etc.
  - NRP topology generation method: Topologies can be created using multiple methods. For example, NRP links can be all links in the native topology, or explicitly selected links from native topology or implicitly selected from the various existing topologies.
  - NRP resource reservation: Reserves link resources for the NRP.
  - NRP control plane: Mechanisms that provide routing and forwarding to one or a group of network slice traffic to ensure the corresponding SLO and SLE through NRP link resources.
  - NRP data plane: Dataplane identifier carried in a data packet, which is used to mark the link resources and behaviors allocated to the NRP.
  - NRP steering policy: Policies for steering slice traffic to the NRP.
- NRP modification or updates: Modifications or additions to existing NRP-allocated resources, e.g. some congested links need to be expanded.
- NRP monitoring: NRP-allocated resources, including NRP-specific link or node SID, link bandwidth usage, link delay, and packet loss status, etc.

NRP Modelling Consideration
An NRP is a subset, or all, of resources allocated from a physical network or logical network. Depending on the SLO and SLE requirements of the slicing service and also the available resources of the operator's network, there are several options of creating an NRP. One option is that each physical link is allocated to only one specific NRP, and different NRPs do not share any physical link. One more typical option is that multiple NRPs share the same physical links, and each NRP is built with virtual links with a certain subset of the bandwidth available on the physical links to provide network resource isolation.
In addition to specifying resource allocation from the underlay network, An NRP also needs to have associated control plane and forwarding plane technologies, which can provide specific routing and forwarding so that the traffic received from NRP edge nodes that is characterized to match the NRP traffic classification rule is constrained to the NRP exclusive topology and resource allocation. The NRP allows network operators to manage the resources of IETF network slices which are used to provide network slice service traffic with specific SLOs and SLEs.
As defined in [I-D.dong-teas-nrp-scalability], the draft discusses NRP control plane and data plane requirements in different provisioning scenarios, and describes that the NRP control plane is used to exchange network resource attributes and associated logical topology information between nodes of the NRP so that NRP-specific routing and forwarding tables could be generated. For the NRP control plane, distributed control plane mechanism, such as Multi-topology, Flex-Algo or centralized SDN or hybrid combination could be defined. To help with forwarding entries, several data-plane encapsulation options are also discussed to carry NRP information in the NRP traffic packets. The example NRP data plane identifier could be the IPv6 addresses or the MPLS forwarding labels or dedicated NRP data-plane identifiers.
An example of NRP instances and a physical network is illustrated in Figure 1. In the example, each NRP instance has a customized network topology comprised of a set of links and nodes in the physical network. In control plane, each NRP could be associated with a multi-topology or a Flex-Algo. And it also has its own forwarding plane resources and identifiers which provide NRP-specific packet forwarding.

An NRP Example
            ++++   ++++   ++++
            +--+===+--+===+--+
            +--+===+--+===+--+
            ++++   +++\\  ++++
             ||     || \\  ||             Physical
             ||     ||  \\ ||             Network
     ++++   ++++   ++++  \\+++   ++++
     +  +===+--+===+--+===+--+===+  +
     +  +===+--+===+--+===+--+===+  +
     ++++   ++++   ++++   ++++   ++++
      PE1                         PE2
                      |
                     \|/

             o----o-----o
            /          /              NRP-1
     o-----o-----o----o----o

             o----o
            /    / \                  NRP-2
     o-----o----o---o------o

                                       ...

                  o----o
                 /    /               NPR-n
     o-----o----o----o-----o

        o   is a virtual node
        --- is a virtual link
[I-D.ietf-teas-ietf-network-slices] also describes the management of the NRP. After an NRP created, the NRP may need to be refined and modified as the network status and slice services change, and could be extended if necessary to meet the customers' demands. In addition to configuration management, the NRP should also provide detailed monitoring information about underlying resources to further provide monitoring for the hosted slice services.

NRP Model Usage example
One major application of network slices is 5G services. Figure 2 shows the use of the NRP model to realize the IETF Network Slice for the 5G use case, based on the reference framework defined in [I-D.ietf-teas-ietf-network-slices]. The figure shows that the NSC uses the L3VPN network model [I-D.ietf-opsawg-l3sm-l3nm] to map to an IETF Network Slice service and uses the NRP model to map VPN traffic to underlying network resources, so that the SLO and SLE required by the IETF network slice service are ensured when the VPN service traverses the underlying network.

Reference Module Use Case
      +------------------------------------------+
      |                 Customer                 |
      |                                          |
      +------------------------------------------+
                           A
                           | IETF Network slice service interface
                           V
      +------------------------------------------+
      |    IETF Network Slice Controller (NSC)   |
      +------------------------------------------+
                           A
                     L3NM  | Network Configuration Interface
                           V    NRP Model
      +------------------------------------------+
      |           Network Controller(s)          |
      +------------------------------------------+
                           A
                           |    Device model
                           V
   +------------------------------------------------+
                         Network

In the process of realizing an IETF network slice service, the NSC can use a static NRP instance or dynamically create one as one or a group of VPNs underlay construct. Compared with existing VPN underlying built with full mesh tunneling mechanisms, the NRP could provide resource isolation, topology constraints, and simplified configuration. Additionally, specific service flows of a VPN can be further optimized using SR policies defined in [I-D.dong-idr-sr-policy-vtn].

NRP Modeling Design
As defined in [I-D.ietf-teas-ietf-network-slices], a network resource partition (NRP) is a collection of resources in the underlay network. An NRP can have a dedicated topology or can use a shared topology with other NRPs.
Therefore, an NRP is modeled as network topology defined in [RFC8345] with augmentations. A new network type "nrp" is defined. A network topology data instance containing the nrp network type, indicates an NRP instance. The Figure 3 shows the relationship between this module and other topology modules.

NRP Model Relationship
              +-----------------------+
              |Network Topology Model |
              |       RFC8345         |
              +-----------------------+
                     |
       +-------------+-------------+-------------+
       |             |             |             |
       V             V             V             V
   +----------+ ............  ............  ............
   |  Network | :   L3     :  :    TE    :  :    L2    :
   | Resource | :Topology  :  : Topology :  : Topology :
   | Partition| :  Model   :  :   Model  :  :   Model  :
   |   Model  | :..........:  :..........:  :..........:
   +----------+
The container "nrp" under 'network' of [RFC8345] defines global parameters for an NRP, which defines NRP partition type, NRP topology generation method, and the specific control plane and data plane mechanisms of an NRP. And also, the traffic steering policy of the NRP may include a dynamic color based policies or an ACL-based static ones.
The NRP partition type is used to describe multiple NRP resource partition methods, for example, no partition, control plane resource partition, data plane resource partition, or a combination of two types.
As an NRP may consist of the entire or a subset of links in the underlay network, there are various methods to generate NRP topology, which include:
The NRP with a subset of links in the underlay network, which has the same topology as the pre-built L3 topology, MT topology, flexalgo, or TE topology, and also has the same resource reservation requirements. The topology definition may come directly from the topology defined by "control plane".
For other NRPs that require a dedicated topology, "nrp-topology-group" is used to configure the selected links from the base topology. Generally, the base topology refers to the underlay network topology. An NRP can be configured with one or more "nrp-topology-group" to create topology resources required by the NRP. For example, if an NRP needs to reserve the same bandwidth for a groups of links, the same "group-id" can be assigned to the links and "bandwidth-reservation" is specified, such as access network link group, aggregation network link group, etc. If some inter-domain links, have multiple bandwidth reservation requirements, they can also be classified into a group. Then, each link can override the bandwidth reservation of the group bandwidth reservation.
As discussed in [I-D.dong-teas-nrp-scalability], an NRP could have multiple control plane implementation options. For a better network scalability, an NRP does not require an independent distributed control protocol instance or a independent centralized control plane instance, that is, multiple NRPs can share a same control plane instance. Thus, an NRP can use a predefined native or abstract TE topology by referring to a TE network instance or a predefined control protocol instance by referring to Layer3 network instance.
In addition to global NRP parameters, each NRP instance also consists of a set of nodes and a set of links, which have different attributes that represent the allocated resources or the operational status of the NRP. An NRP could support several data plane resource partition methods, which are defined by 'link-partition-type'' under an NRP link, which can further be supported by FlexE or independent queue techniques.
There are multiple modes of NRP operations to be supported as follows:
- NRP instantiation: Depending on the slice services types and also network status, there can be two types of approaches. One method is to create an NRP instance before the network controller processes the IETF network slice service request. Another one is that the network controller may start creating an NRP instance while configuring the IETF network slice service request.
- NRP modification: When the capacity of an existing NPR link is close to capacity, the bandwidth of the link could be increased. And when the NRP link or node resources are insufficient, new NRP links and nodes could be added.
- NRP Deletion: If the NSC determines that no slice service is using an NRP, the NSC can delete the NRP instance.
- NRP Monitoring: The NSC can use the NRP model to track and monitor NRP resource status and usage.

Description of NRP YANG Module
The description of the NRP data nodes are as follows:
- "nrp-id": Is an identifier that is used to uniquely identify an NRP instance within the network scope.
- NRP partition type: Refers to control plane resource partition, data plane resource partition, or a combination of two types.
- NRP resources reservation: The nodes and links represent the network resource allocated for an NRP instance. 'bandwidth-reservation' specifies the bandwidth allocated to an NRP instance, or is overridden by the configuration of the NRP link. 'link-partition-type' specifies the resource partition types of the physical interfaces associated with an NRP link.
- NRP control plane: When an NRP shares an IGP instance or TE instance with other NRPs, "igp-topology-ref" or "te-topology-identifier“ is used to refer to the existing IGP network instance or TE instance. And an NRP can further use Multi-Topology Routing (MTR) or Flex-algo to refer to the IGP instance to generate its own NRP-specific forwarding tables. Multi-Topology Routing (MTR) is defined in [RFC4915], [RFC5120], and [I-D.ietf-lsr-isis-sr-vtn-mt] or Flex-algo is defined in [I-D.ietf-lsr-flex-algo].
- NRP data plane: Defines the data plane mechanism and the NRP identifier of the network domain managed by the network controller. The data plane mechanism could be based on MPLS or IPv6 forwarding. The container "data plane" is used to specify the NRP data plane encapsulation types and values that are used to identify NRP-specific network resources. The NRP data plane identifier is defined in [I-D.ietf-spring-sr-for-enhanced-vpn] and[I-D.dong-6man-enhanced-vpn-vtn-id].
- NRP steering policy: The leaf-list "color-id" is used for dynamic traffic steering based on SR policy of an NRP and The leaf-list "acl-ref" is used for common traffic steering.
- NRP topology group: The list "nrp-topology-group" is used to explicitly select subset of links of a underlay topology.

NRP Yang Module Tree
module: ietf-nrp
  augment /nw:networks/nw:network/nw:network-types:
    +--rw nrp!
  augment /nw:networks/nw:network:
    +--rw nrp
       +--rw nrp-id?                  uint32
       +--rw nrp-name?                string
       +--rw partition-type?          identityref
       +--rw bandwidth-reservation
       |  +--rw (bandwidth-type)?
       |     +--:(bandwidth-value)
       |     |  +--rw bandwidth-value?     uint64
       |     +--:(bandwidth-percentage)
       |        +--rw bandwidth-percent?   rt-types:percentage
       +--rw control-plane
       |  +--rw topology-ref
       |     +--rw igp-topology-ref
       |     |  +--rw network-ref?
       |     |  |       -> /nw:networks/network/network-id
       |     |  +--rw multi-topology-id?   uint32
       |     |  +--rw flex-algo-id?        uint32
       |     +--rw te-topology-identifier
       |        +--rw provider-id?   te-global-id
       |        +--rw client-id?     te-global-id
       |        +--rw topology-id?   te-topology-id
       +--rw data-plane
       |  +--rw global-resource-identifier
       |  |  +--rw nrp-dataplane-ipv6-type
       |  |  |  +--rw nrp-dp-value?   inet:ipv6-address
       |  |  +--rw nrp-dataplane-mpls-type
       |  |     +--rw nrp-dp-value?   uint32
       |  +--rw nrp-aware-dp
       |     +--rw nrp-aware-srv6-type!
       |     +--rw nrp-aware-sr-mpls-type!
       +--rw steering-policy
       |  +--rw color-id*   uint32
       |  +--rw acl-ref*    -> /acl:acls/acl/name
       +--rw nrp-topology-group* [group-id]
          +--rw group-id                 string
          +--rw base-topology-ref
          |  +--rw network-ref?   -> /nw:networks/network/network-id
          +--rw links* [link-ref]
          |  +--rw link-ref                    leafref
          |  +--rw link-attributes-override
          |     +--rw bandwidth-reservation
          |        +--rw (bandwidth-type)?
          |           +--:(bandwidth-value)
          |           |  +--rw bandwidth-value?     uint64
          |           +--:(bandwidth-percentage)
          |              +--rw bandwidth-percent?
          |                      rt-types:percentage
          +--rw bandwidth-reservation
             +--rw (bandwidth-type)?
                +--:(bandwidth-value)
                |  +--rw bandwidth-value?     uint64
                +--:(bandwidth-percentage)
                   +--rw bandwidth-percent?   rt-types:percentage
  augment /nw:networks/nw:network/nw:node:
    +--ro nrp
       +--ro nrp-aware-dp-id
          +--ro nrp-dp-srv6?      srv6-types:srv6-sid
          +--ro nrp-dp-sr-mpls?   rt-types:mpls-label
  augment /nw:networks/nw:network/nt:link:
    +--rw nrp
       +--rw bandwidth-reservation
       |  +--rw (bandwidth-type)?
       |     +--:(bandwidth-value)
       |     |  +--rw bandwidth-value?     uint64
       |     +--:(bandwidth-percentage)
       |        +--rw bandwidth-percent?   rt-types:percentage
       +--rw partition-type?          identityref
       +--ro nrp-aware-dp-id
       |  +--ro nrp-dp-srv6?      srv6-types:srv6-sid
       |  +--ro nrp-dp-sr-mpls?   rt-types:mpls-label
       +--ro statistics
          +--ro admin-status?
          |       te-types:te-admin-status
          +--ro oper-status?
          |       te-types:te-oper-status
          +--ro one-way-available-bandwidth?
          |       rt-types:bandwidth-ieee-float32
          +--ro one-way-utilized-bandwidth?
          |       rt-types:bandwidth-ieee-float32
          +--ro one-way-min-delay?             uint32
          +--ro one-way-max-delay?             uint32
          +--ro one-way-delay-variation?       uint32
          +--ro one-way-packet-loss?           decimal64

NRP Yang Module
<CODE BEGINS> file "ietf-nrp@2022-07-11.yang"
module ietf-nrp {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-nrp";
  prefix nrp;

  import ietf-network {
    prefix nw;
    reference
      "RFC 8345: A YANG Data Model for Network Topologies";
  }
  import ietf-network-topology {
    prefix nt;
    reference
      "RFC 8345: A YANG Data Model for Network Topologies";
  }
  import ietf-routing-types {
    prefix rt-types;
    reference
      "RFC 8294: Common YANG Data Types for the Routing Area";
  }
  import ietf-te-types {
    prefix te-types;
    reference
      "RFC 8776: Traffic Engineering Common YANG Types";
  }
  import ietf-te-packet-types {
    prefix te-packet-types;
    reference
      "RFC 8776: Traffic Engineering Common YANG Types";
  }
  import ietf-srv6-types {
    prefix srv6-types;
  }
  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types";
  }
  import ietf-access-control-list {
    prefix acl;
    reference
      "RFC 8519: YANG Data Model for Network Access Control Lists
       (ACLs)";
  }

  organization
    "IETF TEAS Working Group";
  contact
    "
     WG Web: <http://tools.ietf.org/wg/teas/>
     WG List:<mailto:teas@ietf.org>

     Editor: Bo Wu <lana.wubo@huawei.com>
           : Dhruv Dhody <dhruv.ietf@gmail.com>";
  description
    "This YANG module defines a network data module for
     NRP(Network Resource Partition).

     Copyright (c) 2022 IETF Trust and the persons identified as
     authors of the code.  All rights reserved.

     Redistribution and use in source and binary forms, with or
     without modification, is permitted pursuant to, and subject
     to the license terms contained in, the Revised BSD License
     set forth in Section 4.c of the IETF Trust's Legal Provisions
     Relating to IETF Documents
        (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC XXXX
     (https://www.rfc-editor.org/info/rfcXXXX); see the RFC itself
     for full legal notices.";

  revision 2022-07-11 {
    description
      "This is the initial version of NRP YANG model.";
    reference
      "RFC XXX: A YANG Data Model for Network Resource Partition";
  }

  identity nrp-partition-type {
    description
      "Base identity for NRP partition type.";
  }

  identity nrp-control-plane-partition {
    base nrp-partition-type;
    description
      "Identity for control plane partition.";
  }

  identity nrp-data-plane-partition {
    base nrp-partition-type;
    description
      "Identity for data plane partition.";
  }

  identity nrp-hybrid-plane-partition {
    base nrp-partition-type;
    description
      "Identity for both planes partition.";
  }

  identity nrp-no-partition {
    base nrp-partition-type;
    description
      "Identity for no partition.";
  }

  identity nrp-link-partition-type {
    description
      "Base identity for interface partition type.";
  }

  identity virtual-sub-interface-partition {
    base nrp-link-partition-type;
    description
      "Identity for virtual interface or sub-interface, e.g. FlexE.";
  }

  identity queue-partition {
    base nrp-link-partition-type;
    description
      "Identity for queue partition type.";
  }

  identity nrp-dataplane-type {
    description
      "Base identity for NRP data plane type.";
  }

  identity nrp-dataplane-ipv6 {
    base nrp-dataplane-type;
    description
      "Identity for NRP specific packet forwarding of IPv6.";
  }

  identity nrp-dataplane-mpls {
    base nrp-dataplane-type;
    description
      "Identity for NRP specific packet forwarding of MPLS.";
  }

  identity nrp-dataplane-sr-mpls {
    base nrp-dataplane-type;
    description
      "Identity for NRP specific packet forwarding of SR MPLS.";
  }

  identity nrp-dataplane-srv6 {
    base nrp-dataplane-type;
    description
      "Identity for NRP specific packet forwarding of SRv6.";
  }

  /*
   * Groupings
   */

  grouping nrp-bandwidth-reservation {
    description
      "Grouping for NRP bandwidth reservation.";
    container bandwidth-reservation {
      description
        "Container for NRP bandwidth reservation.";
      choice bandwidth-type {
        description
          "Choice of bandwidth reservation type.";
        case bandwidth-value {
          leaf bandwidth-value {
            type uint64;
            units "bps";
            description
              "Bandwidth allocation for the NRP as absolute value.";
          }
        }
        case bandwidth-percentage {
          leaf bandwidth-percent {
            type rt-types:percentage;
            description
              "Bandwidth allocation for the NRP as a percentage
               of a link.";
          }
        }
      }
    }
  }

  grouping nrp-control-plane-attributes {
    description
      "Grouping for NRP control plane attributes.";
    container control-plane {
      description
        "The container of NRP control plane mechanisms.";
      container topology-ref {
        description
          "Container for topology reference.";
        container igp-topology-ref {
          description
            "Container for IGP topology reference.";
          uses nw:network-ref;
          leaf multi-topology-id {
            type uint32;
            description
              "The MT-id of an NRP.";
          }
          leaf flex-algo-id {
            type uint32;
            description
              "The flex-algo-id of an NRP.";
          }
        }
        uses te-types:te-topology-identifier;
      }
    }
  }

  grouping nrp-data-plane-attributes {
    description
      "Grouping for NRP data plane attributes.";
    container data-plane {
      description
        "The data plane mechanisms of an NRP. The forwarding plane
         could be MPLS, IPv6, SRv6, or SR-MPLS.";
      container global-resource-identifier {
        description
          "The container of global NRP data-plane ID.";
        container nrp-dataplane-ipv6-type {
          description
            "The container of IPv6 based NRP data-plane identifier.";
          leaf nrp-dp-value {
            type inet:ipv6-address;
            description
              "Indicates the IPv6 NRP data-plane identifier.";
          }
        }
        container nrp-dataplane-mpls-type {
          description
            "The container of MPLS based NRP data-plane identifier.";
          leaf nrp-dp-value {
            type uint32;
            description
              "Indicates MPLS metadata values to identify MPLS NRP
               data plane identifier, e.g. Ancillary data.";
          }
        }
      }
      container nrp-aware-dp {
        description
          "The container of SR based NRP data-plane identifier.";
        container nrp-aware-srv6-type {
          presence "Enables SRv6 data plane type.";
          description
            "The container of SRv6 based NRP data-plane identifier.";
        }
        container nrp-aware-sr-mpls-type {
          presence "Enables SR MPLS data plane type.";
          description
            "The container of SR MPLS based NRP data-plane identifier.";
        }
      }
    }
  }

  grouping nrp-traffic-steering-policy {
    description
      "The grouping of the NRP traffic steering policy.";
    container steering-policy {
      description
        "The container of a policy set
         matching an NRP traffic classifier.";
      leaf-list color-id {
        type uint32;
        description
          "A list of color ID for NRP traffic steering based on
           SR policy.";
      }
      leaf-list acl-ref {
        type leafref {
          path "/acl:acls/acl:acl/acl:name";
        }
        description
          "A list of ACL for NRP traffic classification.";
      }
    }
  }

  grouping nrp-aware-id {
    description
      "The grouping of NRP aware dataplane ID.";
    container nrp-aware-dp-id {
      config false;
      description
        "The container of NRP data plane identifier.";
      leaf nrp-dp-srv6 {
        type srv6-types:srv6-sid;
        description
          "Indicates the SRv6 SID value as the NRP data plane
           identifier.";
      }
      leaf nrp-dp-sr-mpls {
        type rt-types:mpls-label;
        description
          "Indicates the SR MPLS ID value as the NRP data plane
           identifier.";
      }
    }
  }

  grouping nrp-topology-attributes {
    description
      "NRP global attributes.";
    container nrp {
      description
        "Containing NRP topology attributes.";
      leaf nrp-id {
        type uint32;
        description
          "NRP identifier.";
      }
      leaf nrp-name {
        type string;
        description
          "NRP Name.";
      }
      leaf partition-type {
        type identityref {
          base nrp-partition-type;
        }
        default "nrp-no-partition";
        description
          "Indicates the resource partition type of the NRP, such as
           control plane partition, data plane partition,
           or no partition.";
      }
      uses nrp-bandwidth-reservation;
      uses nrp-control-plane-attributes;
      uses nrp-data-plane-attributes;
      uses nrp-traffic-steering-policy;
      list nrp-topology-group {
        key "group-id";
        description
          "List of groups for NRP topology elements (node or links)
           that share common attributes.";
        leaf group-id {
          type string;
          description
            "The NRP topology group identifier.";
        }
        container base-topology-ref {
          description
            "Container for the base topology reference.";
          uses nw:network-ref;
        }
        list links {
          key "link-ref";
          description
            "A list of links with common attributes";
          leaf link-ref {
            type leafref {
              path
                "/nw:networks/nw:network[nw:network-id=current()"
              + "/../../base-topology-ref/network-ref]"
              + "/nt:link/nt:link-id";
            }
            description
              "A reference to a link in the base topology.";
          }
          container link-attributes-override {
            description
              "Container for overriding link attributes,
               e.g. resource reservation.";
            uses nrp-bandwidth-reservation;
          }
        }
        uses nrp-bandwidth-reservation;
      }
    }
    // nrp
  }

  // nrp-node-attributes

  grouping nrp-node-attributes {
    description
      "NRP node scope attributes.";
    container nrp {
      config false;
      description
        "Containing NRP attributes.";
      uses nrp-aware-id;
    }
  }

  // nrp-node-attributes

  grouping nrp-link-states {
    description
      "NRP link scope states.";
    container nrp {
      description
        "Containing NRP attributes.";
      uses nrp-bandwidth-reservation;
      leaf partition-type {
        type identityref {
          base nrp-partition-type;
        }
        description
          "Indicates the resource partition type of a link.";
      }
      uses nrp-aware-id;
      uses nrp-statistics-per-link;
    }
  }

  // one-way-performance-metrics

  grouping one-way-performance-bandwidth {
    description
      "Grouping for one-way performance bandwidth.";
    leaf one-way-available-bandwidth {
      type rt-types:bandwidth-ieee-float32;
      units "bytes per second";
      default "0x0p0";
      description
        "Available bandwidth that is defined to be NRP link
         bandwidth minus bandwidth utilization. For a
         bundled link, available bandwidth is defined to be the
         sum of the component link available bandwidths.";
    }
    leaf one-way-utilized-bandwidth {
      type rt-types:bandwidth-ieee-float32;
      units "bytes per second";
      default "0x0p0";
      description
        "Bandwidth utilization that represents the actual
         utilization of the link (i.e. as measured in the router).
         For a bundled link, bandwidth utilization is defined to
         be the sum of the component link bandwidth
         utilizations.";
    }
  }

  // nrp-link-statistics

  grouping nrp-statistics-per-link {
    description
      "Statistics attributes per NRP link.";
    container statistics {
      config false;
      description
        "Statistics for NRP link.";
      leaf admin-status {
        type te-types:te-admin-status;
        description
          "The administrative state of the link.";
      }
      leaf oper-status {
        type te-types:te-oper-status;
        description
          "The current operational state of the link.";
      }
      uses one-way-performance-bandwidth;
      uses te-packet-types:one-way-performance-metrics-packet;
    }
  }

  grouping nrp-augment {
    description
      "Augmentation for NRPs.";
    container nrp {
      presence "NRP support";
      description
        "Indicates NRP support.";
    }
    // nrp
  }

  // nrp-augment

  augment "/nw:networks/nw:network/nw:network-types" {
    description
      "Defines the NRP topology type.";
    container nrp {
      presence "Indicates NRP topology";
      description
        "The presence identifies the NRP type.";
    }
  }

  augment "/nw:networks/nw:network" {
    when 'nw:network-types/nrp:nrp' {
      description
        "Augment only for NRP topology.";
    }
    description
      "Augment NRP configuration and state.";
    uses nrp-topology-attributes;
  }

  augment "/nw:networks/nw:network/nw:node" {
    when '../nw:network-types/nrp:nrp' {
      description
        "Augment only for NRP topology.";
    }
    description
      "Augment node configuration and state.";
    uses nrp-node-attributes;
  }

  augment "/nw:networks/nw:network/nt:link" {
    when '../nw:network-types/nrp:nrp' {
      description
        "Augment only for NRP topology.";
    }
    description
      "Augment link configuration and state.";
    uses nrp-link-states;
  }
}

<CODE ENDS>

Security Considerations
The YANG module defined in this document is designed to be accessed via network management protocols such as NETCONF [RFC6241] or RESTCONF [RFC8040]. The lowest NETCONF layer is the secure transport layer, and the mandatory-to-implement secure transport is Secure Shell (SSH) [RFC6242]. The lowest RESTCONF layer is HTTPS, and the mandatory-to-implement secure transport is TLS [RFC8446].
The NETCONF access control model [RFC8341] provides the means to restrict access for particular NETCONF or RESTCONF users to a preconfigured subset of all available NETCONF or RESTCONF protocol operations and content.
There are a number of data nodes defined in this YANG module that are writable/creatable/deletable (i.e., config true, which is the default). These data nodes may be considered sensitive or vulnerable in some network environments. Write operations (e.g., edit-config) to these data nodes without proper protection can have a negative effect on network operations.
nrp-link: A malicious client could attempt to remove a link from a topology, add a new link. In each case, the structure of the topology would be sabotaged, and this scenario could, for example, result in an NRP topology that is less than optimal.
The entries in the nodes above include the whole network configurations corresponding with the NRP, and indirectly create or modify the PE or P device configurations. Unexpected changes to these entries could lead to service disruption and/or network misbehavior.

IANA Considerations
This document registers a URI in the IETF XML registry [RFC3688]. Following the format in [RFC3688], the following registration is requested to be made:

   URI: urn:ietf:params:xml:ns:yang:ietf-nrp
   Registrant Contact: The IESG.
   XML: N/A, the requested URI is an XML namespace.

This document requests to register a YANG module in the YANG Module Names registry [RFC7950].

           Name: ietf-nrp
           Namespace: urn:ietf:params:xml:ns:yang:ietf-nrp
           Prefix: nrp
           Reference: RFC XXXX

Contributor
   Zhenbin Li
   Huawei

   Email: lizhenbin@huawei.com

   Jie Dong
   Huawei

   Email: jie.dong@huawei.com

Normative References

Informative References
[I-D.ietf-teas-ietf-network-slices]
[I-D.dong-teas-nrp-scalability]
[RFC8309]
[RFC6241]
[RFC7950]
[RFC8340]
[I-D.ietf-teas-ns-ip-mpls]
[I-D.ietf-opsawg-l3sm-l3nm]
[I-D.dong-idr-sr-policy-vtn]
[RFC8345]
[RFC4915]
[RFC5120]
[I-D.ietf-lsr-isis-sr-vtn-mt]
[I-D.ietf-lsr-flex-algo]
[I-D.ietf-spring-sr-for-enhanced-vpn]
[I-D.dong-6man-enhanced-vpn-vtn-id]
[RFC8040]
[RFC6242]
[RFC8446]
[RFC8341]
[RFC3688]
[RFC7951]

An Example
This section contains an example of an instance data tree in JSON encoding [RFC7951]. The example instantiates ietf-nrp for the topology that is depicted in the following diagram. There are three nodes, D1, D2, and D3. D1 has three termination points, 1-0-1, 1-2-1, and 1-3-1. D2 has three termination points as well, 2-1-1, 2-0-1, and 2-3-1. D3 has two termination points, 3-1-1 and 3-2-1. In addition there are six links, two between each pair of nodes with one going in each direction.

An NRP Instance Example

             +------------+                   +------------+
             |     D1     |                   |     D2     |
            /-\          /-\                 /-\          /-\
            | | 1-0-1    | |---------------->| | 2-1-1    | |
            | |    1-2-1 | |<----------------| |    2-0-1 | |
            \-/  1-3-1   \-/                 \-/  2-3-1   \-/
             |   /----\   |                   |   /----\   |
             +---|    |---+                   +---|    |---+
                 \----/                           \----/
                  |  |                             |  |
                  |  |                             |  |
                  |  |                             |  |
                  |  |       +------------+        |  |
                  |  |       |     D3     |        |  |
                  |  |      /-\          /-\       |  |
                  |  +----->| | 3-1-1    | |-------+  |
                  +---------| |    3-2-1 | |<---------+
                            \-/          \-/
                             |            |
                             +------------+

The corresponding NRP instance data tree is depicted below:

Instance data tree
{
  "ietf-network:networks": {
    "network": [
      {
        "network-types": {
          "ietf-nrp:nrp": {}
        },
        "network-id": "nrp-example",
        "ietf-nrp:nrp": {
          "nrp-id": "1",
          "nrp-name": "NRP1",
          "partition-type": "nrp-data-plane-partition",
          "bandwidth-reservation": {
            "bandwidth-value": "10000"
          },
          "control-plane": {
            "topology-ref": {
              "igp-topology-ref": {
                " network-ref": "L3-topology-1",
                " flex-algo-id": "129"
              }
            }
          },
          "data-plane": {
            "global-resource-identifier": {
              "nrp-dataplane-ipv6-type": {
                " nrp-dp-value:": "100"
              }
            }
          },
          "steering-policy": {
            "color-id": "100"
          },
          "nrp-topology-group": [
            {
              "group-id": "group1",
              "base-topology-ref": {
                "network-ref": "native-topology"
              }
            }
          ]
        },
        "node": [
          {
            "node-id": "D1",
            "termination-point": [
              {
                "tp-id": "1-0-1"
              },
              {
                "tp-id": "1-2-1"
              },
              {
                "tp-id": "1-3-1"
              }
            ]
          },
          {
            "node-id": "D2",
            "termination-point": [
              {
                "tp-id": "2-0-1"
              },
              {
                "tp-id": "2-1-1"
              },
              {
                "tp-id": "2-3-1"
              }
            ]
          },
          {
            "node-id": "D3",
            "termination-point": [
              {},
              {
                "tp-id": "3-2-1"
              }
            ]
          }
        ],
        "ietf-network-topology:link": [
          {
            "link-id": "D1,1-2-1,D2,2-1-1",
            "source": {
              "source-node": "D1",
              "source-tp": "1-2-1"
            },
            "destination": {
              "dest-node": "D2",
              "dest-tp": "2-1-1"
            },
            "ietf-nrp:nrp": {
              "partition-type": "virtual-sub-interface-partition",
              "bandwidth-reservation": {
                "bandwidth-value": "10000"
              }
            }
          },
          {
            "link-id": "D2,2-1-1,D1,1-2-1",
            "source": {
              "source-node": "D2",
              "source-tp": "2-1-1"
            },
            "destination": {
              "dest-node": "D1",
              "dest-tp": "1-2-1"
            },
            "ietf-nrp:nrp": {
              "partition-type": "virtual-sub-interface-partition",
              "bandwidth-reservation": {
                "bandwidth-value": "10000"
              }
            }
          },
          {
            "link-id": "D1,1-3-1,D3,3-1-1",
            "source": {
              "source-node": "D1",
              "source-tp": "1-3-1"
            },
            "destination": {
              "dest-node": "D3",
              "dest-tp": "3-1-1"
            },
            "ietf-nrp:nrp": {
              "partition-type": "virtual-sub-interface-partition",
              "bandwidth-reservation": {
                "bandwidth-value": "10000"
              }
            }
          },
          {
            "link-id": "D3,3-1-1,D1,1-3-1",
            "source": {
              "source-node": "D3",
              "source-tp": "3-1-1"
            },
            "destination": {
              "dest-node": "D1",
              "dest-tp": "1-3-1"
            },
            "ietf-nrp:nrp": {
              "partition-type": "virtual-sub-interface-partition",
              "bandwidth-reservation": {
                "bandwidth-value": "10000"
              }
            }
          },
          {
            "link-id": "D2,2-3-1,D3,3-2-1",
            "source": {
              "source-node": "D2",
              "source-tp": "2-3-1"
            },
            "destination": {
              "dest-node": "D3",
              "dest-tp": "3-2-1"
            },
            "ietf-nrp:nrp": {
              "partition-type": "virtual-sub-interface-partition",
              "bandwidth-reservation": {
                "bandwidth-value": "10000"
              }
            }
          },
          {
            "link-id": "D3,3-2-1,D2,2-3-1",
            "source": {
              "source-node": "D3",
              "source-tp": "3-2-1"
            },
            "destination": {
              "dest-node": "D2",
              "dest-tp": "2-3-1"
            },
            "ietf-nrp:nrp": {
              "partition-type": "virtual-sub-interface-partition",
              "bandwidth-reservation": {
                "bandwidth-value": "10000"
              }
            }
          }
        ]
      }
    ]
  }
}